3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Keep the original TERM for say_color
21 # Test the binaries we have just built. The tests are kept in
22 # t/ subdirectory and are run in 'trash directory' subdirectory.
23 if test -z "$TEST_DIRECTORY"
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
30 if test -z "$TEST_OUTPUT_DIRECTORY"
32 # Similarly, override this to store the test-results subdir
34 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38 ################################################################
39 # It appears that people try to run tests without building...
40 "$GIT_BUILD_DIR/git" >/dev/null
43 echo >&2 'error: you do not seem to have built git yet.'
47 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
48 export PERL_PATH SHELL_PATH
50 # if --tee was passed, write the output not only to the terminal, but
51 # additionally to the file test-results/$BASENAME.out, too.
52 case "$GIT_TEST_TEE_STARTED, $* " in
54 # do not redirect again
56 *' --tee '*|*' --va'*)
57 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
58 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
59 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
60 echo $? > $BASE.exit) | tee $BASE.out
61 test "$(cat $BASE.exit)" = 0
66 # For repeatability, reset the environment to known value.
72 export LANG LC_ALL PAGER TERM TZ
74 # A call to "unset" with no arguments causes at least Solaris 10
75 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
76 # deriving from the command substitution clustered with the other
78 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
80 my $ok = join("|", qw(
91 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
92 print join("\n", @vars);
96 GIT_AUTHOR_EMAIL=author@example.com
97 GIT_AUTHOR_NAME='A U Thor'
98 GIT_COMMITTER_EMAIL=committer@example.com
99 GIT_COMMITTER_NAME='C O Mitter'
100 GIT_MERGE_VERBOSITY=5
101 GIT_MERGE_AUTOEDIT=no
102 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
103 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
104 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
107 # Add libc MALLOC and MALLOC_PERTURB test
108 # only if we are not executing the test with valgrind
109 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
110 test -n "$TEST_NO_MALLOC_CHECK"
112 setup_malloc_check () {
115 teardown_malloc_check () {
119 setup_malloc_check () {
120 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
121 export MALLOC_CHECK_ MALLOC_PERTURB_
123 teardown_malloc_check () {
124 unset MALLOC_CHECK_ MALLOC_PERTURB_
128 # Protect ourselves from common misconfiguration to export
129 # CDPATH into the environment
135 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
137 echo "* warning: Some tests will not work if GIT_TRACE" \
138 "is set as to trace on STDERR ! *"
139 echo "* warning: Please set GIT_TRACE to something" \
140 "other than 1, 2 or true ! *"
146 # A regexp to match 5 and 40 hexdigits
147 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
148 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
151 _z40=0000000000000000000000000000000000000000
157 export _x05 _x40 _z40 LF
159 # Each test should start with something like this, after copyright notices:
161 # test_description='Description of this test...
162 # This test checks if command xyzzy does the right thing...
165 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
166 TERM=$ORIGINAL_TERM &&
169 tput bold >/dev/null 2>&1 &&
170 tput setaf 1 >/dev/null 2>&1 &&
171 tput sgr0 >/dev/null 2>&1
175 while test "$#" -ne 0
178 -d|--d|--de|--deb|--debu|--debug)
180 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
181 immediate=t; shift ;;
182 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
183 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
184 -h|--h|--he|--hel|--help)
186 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
189 verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
191 -q|--q|--qu|--qui|--quie|--quiet)
192 # Ignore --quiet under a TAP::Harness. Saying how many tests
193 # passed without the ok/not ok details is always an error.
194 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
196 with_dashes=t; shift ;;
199 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
203 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
206 valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
208 --valgrind-parallel=*)
209 valgrind_parallel=$(expr "z$1" : 'z[^=]*=\(.*\)')
211 --valgrind-only-stride=*)
212 valgrind_only_stride=$(expr "z$1" : 'z[^=]*=\(.*\)')
214 --valgrind-only-offset=*)
215 valgrind_only_offset=$(expr "z$1" : 'z[^=]*=\(.*\)')
218 shift ;; # was handled already
220 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
223 statusprefix=$(expr "z$1" : 'z[^=]*=\(.*\)')
226 echo "error: unknown test option '$1'" >&2; exit 1 ;;
230 if test -n "$valgrind_only" || test -n "$valgrind_only_stride"
232 test -z "$valgrind" && valgrind=memcheck
233 test -z "$verbose" && verbose_only="$valgrind_only"
234 elif test -n "$valgrind"
247 tput bold; tput setaf 1;; # bold red
249 tput setaf 4;; # blue
251 tput setaf 3;; # brown/yellow
253 tput setaf 2;; # green
255 tput setaf 6;; # cyan
257 test -n "$quiet" && return;;
267 test -z "$1" && test -n "$quiet" && return
274 say_color error "error: $*"
283 test "${test_description}" != "" ||
284 error "Test script did not set test_description."
286 if test "$help" = "t"
288 echo "$test_description"
294 if test "$verbose" = "t"
298 exec 4>/dev/null 3>/dev/null
307 test_external_has_tap=0
311 if test -n "$GIT_EXIT_OK"
315 echo >&5 "FATAL: Unexpected exit with code $code"
323 # The user-facing functions are loaded from a separate file so that
324 # test_perf subshells can have them too
325 . "$TEST_DIRECTORY/test-lib-functions.sh"
327 # You are not expected to call test_ok_ and test_failure_ directly, use
328 # the text_expect_* functions instead.
331 test_success=$(($test_success + 1))
332 say_color "" "${statusprefix}ok $test_count - $@"
336 test_failure=$(($test_failure + 1))
337 say_color error "${statusprefix}not ok $test_count - $1"
339 echo "$@" | sed -e 's/^/# /'
340 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
343 test_known_broken_ok_ () {
344 test_fixed=$(($test_fixed+1))
345 say_color error "${statusprefix}ok $test_count - $@ # TODO known breakage vanished"
348 test_known_broken_failure_ () {
349 test_broken=$(($test_broken+1))
350 say_color warn "${statusprefix}not ok $test_count - $@ # TODO known breakage"
354 test "$debug" = "" || eval "$1"
357 match_pattern_list () {
360 test -z "$*" && return 1
371 maybe_teardown_verbose () {
372 test -z "$verbose_only" && return
373 exec 4>/dev/null 3>/dev/null
378 maybe_setup_verbose () {
379 test -z "$verbose_only" && return
380 if match_pattern_list $test_count $verbose_only ||
381 { test -n "$valgrind_only_stride" &&
382 expr $test_count "%" $valgrind_only_stride - $valgrind_only_offset = 0 >/dev/null; }
385 # Emit a delimiting blank line when going from
386 # non-verbose to verbose. Within verbose mode the
387 # delimiter is printed by test_expect_*. The choice
388 # of the initial $last_verbose is such that before
389 # test 1, we do not print it.
390 test -z "$last_verbose" && echo >&3 ""
393 exec 4>/dev/null 3>/dev/null
396 last_verbose=$verbose
399 maybe_teardown_valgrind () {
400 test -z "$GIT_VALGRIND" && return
401 GIT_VALGRIND_ENABLED=
404 maybe_setup_valgrind () {
405 test -z "$GIT_VALGRIND" && return
406 if test -z "$valgrind_only" && test -z "$valgrind_only_stride"
408 GIT_VALGRIND_ENABLED=t
411 GIT_VALGRIND_ENABLED=
412 if match_pattern_list $test_count $valgrind_only
414 GIT_VALGRIND_ENABLED=t
415 elif test -n "$valgrind_only_stride" &&
416 expr $test_count "%" $valgrind_only_stride - $valgrind_only_offset = 0 >/dev/null
418 GIT_VALGRIND_ENABLED=t
423 # This is a separate function because some tests use
424 # "return" to end a test_expect_success block early.
425 eval </dev/null >&3 2>&4 "$*"
434 teardown_malloc_check
436 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
439 test_eval_ "$test_cleanup"
440 teardown_malloc_check
442 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
450 test_count=$(($test_count+1))
457 maybe_teardown_valgrind
458 maybe_teardown_verbose
463 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
467 if test -z "$to_skip" && test -n "$test_prereq" &&
468 ! test_have_prereq "$test_prereq"
475 if test "$missing_prereq" != "$test_prereq"
477 of_prereq=" of $test_prereq"
480 say_color skip >&3 "${statusprefix}skipping test: $@"
481 say_color skip "${statusprefix}ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
490 # stub; perf-lib overrides it
491 test_at_end_hook_ () {
498 # Note: t0000 relies on $HARNESS_ACTIVE disabling the .counts
500 if test -z "$HARNESS_ACTIVE"
502 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
503 mkdir -p "$test_results_dir"
505 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
507 cat >>"$test_results_path" <<-EOF
509 success $test_success
517 if test "$test_fixed" != 0
519 say_color error "${statusprefix}# $test_fixed known breakage(s) vanished; please update test(s)"
521 if test "$test_broken" != 0
523 say_color warn "${statusprefix}# still have $test_broken known breakage(s)"
525 if test "$test_broken" != 0 || test "$test_fixed" != 0
527 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
528 msg="remaining $test_remaining test(s)"
530 test_remaining=$test_count
531 msg="$test_count test(s)"
533 case "$test_failure" in
535 # Maybe print SKIP message
536 if test -n "$skip_all" && test $test_count -gt 0
538 error "Can't use skip_all after running some tests"
540 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
542 if test $test_external_has_tap -eq 0
544 if test $test_remaining -gt 0
546 say_color pass "${statusprefix}# passed all $msg"
548 say "${statusprefix}1..$test_count$skip_all"
551 test -d "$remove_trash" &&
552 cd "$(dirname "$remove_trash")" &&
553 rm -rf "$(basename "$remove_trash")"
560 if test $test_external_has_tap -eq 0
562 say_color error "${statusprefix}# failed $test_failure among $msg"
563 say "${statusprefix}1..$test_count"
572 # Set up a directory that we can put in PATH which redirects all git
573 # calls to 'valgrind git ...'.
574 if test -n "$valgrind"
578 test "$1" = "$(readlink "$2")" || {
586 while test -d "$2".lock
588 say "Waiting for lock on $2."
595 make_valgrind_symlink () {
596 # handle only executables, unless they are shell libraries that
597 # need to be in the exec-path. We will just use "#!" as a
598 # guess for a shell-script, since we have no idea what the user
599 # may have configured as the shell path.
601 test "#!" = "$(head -c 2 <"$1")" ||
604 base=$(basename "$1")
605 symlink_target=$GIT_BUILD_DIR/$base
606 # do not override scripts
607 if test -x "$symlink_target" &&
608 test ! -d "$symlink_target" &&
609 test "#!" != "$(head -c 2 < "$symlink_target")"
611 symlink_target=../valgrind.sh
615 symlink_target=../unprocessed-script
617 # create the link, or replace it if it is out of date
618 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
621 # In the case of --valgrind-parallel, we only need to do the
622 # wrapping once, in the main script. The worker children all
623 # have $valgrind_only_stride set, so we can skip based on that.
624 if test -z "$valgrind_only_stride"
626 # override all git executables in TEST_DIRECTORY/..
627 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
628 mkdir -p "$GIT_VALGRIND"/bin
629 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
631 make_valgrind_symlink $file
633 # special-case the mergetools loadables
634 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
639 ls "$path"/git-* 2> /dev/null |
642 make_valgrind_symlink "$file"
647 PATH=$GIT_VALGRIND/bin:$PATH
648 GIT_EXEC_PATH=$GIT_VALGRIND/bin
650 GIT_VALGRIND_MODE="$valgrind"
651 export GIT_VALGRIND_MODE
652 GIT_VALGRIND_ENABLED=t
653 if test -n "$valgrind_only" || test -n "$valgrind_only_stride"
655 GIT_VALGRIND_ENABLED=
657 export GIT_VALGRIND_ENABLED
658 elif test -n "$GIT_TEST_INSTALLED"
660 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
661 error "Cannot run git from $GIT_TEST_INSTALLED."
662 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
663 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
664 else # normal case, use ../bin-wrappers only unless $with_dashes:
665 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
666 if ! test -x "$git_bin_dir/git"
668 if test -z "$with_dashes"
670 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
674 PATH="$git_bin_dir:$PATH"
675 GIT_EXEC_PATH=$GIT_BUILD_DIR
676 if test -n "$with_dashes"
678 PATH="$GIT_BUILD_DIR:$PATH"
681 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
683 GIT_CONFIG_NOSYSTEM=1
685 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
687 if test -z "$GIT_TEST_CMP"
689 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
691 GIT_TEST_CMP="$DIFF -c"
693 GIT_TEST_CMP="$DIFF -u"
697 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
699 test -d "$GIT_BUILD_DIR"/templates/blt || {
700 error "You haven't built things yet, have you?"
703 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
705 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
707 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
708 error "You haven't built git_remote_helpers yet, have you?"
712 if ! test -x "$GIT_BUILD_DIR"/test-chmtime
714 echo >&2 'You need to build test-chmtime:'
715 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
720 TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
721 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
722 case "$TRASH_DIRECTORY" in
723 /*) ;; # absolute path is good
724 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
726 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
727 rm -fr "$TRASH_DIRECTORY" || {
729 echo >&5 "FATAL: Cannot prepare test area"
733 HOME="$TRASH_DIRECTORY"
736 if test -z "$TEST_NO_CREATE_REPO"
738 test_create_repo "$TRASH_DIRECTORY"
740 mkdir -p "$TRASH_DIRECTORY"
743 # Gross hack to spawn N sub-instances of the tests in parallel, and
744 # summarize the results. Note that if this is enabled, the script
745 # terminates at the end of this 'if' block.
746 if test -n "$valgrind_parallel"
748 for i in $(test_seq 1 $valgrind_parallel)
750 root="$TRASH_DIRECTORY/vgparallel-$i"
752 TEST_OUTPUT_DIRECTORY="$root" \
754 --root="$root" --statusprefix="[$i] " \
755 --valgrind="$valgrind" \
756 --valgrind-only-stride="$valgrind_parallel" \
757 --valgrind-only-offset="$i" &
760 trap "kill $pids" INT TERM HUP
763 for i in $(test_seq 1 $valgrind_parallel)
765 root="$TRASH_DIRECTORY/vgparallel-$i"
766 eval "$(cat "$root/test-results/$(basename "$0" .sh)"-*.counts |
767 sed 's/^\([a-z][a-z]*\) \([0-9][0-9]*\)/inner_\1=\2/')"
768 test_count=$(expr $test_count + $inner_total)
769 test_success=$(expr $test_success + $inner_success)
770 test_fixed=$(expr $test_fixed + $inner_fixed)
771 test_broken=$(expr $test_broken + $inner_broken)
772 test_failure=$(expr $test_failure + $inner_failed)
777 # Use -P to resolve symlinks in our working directory so that the cwd
778 # in subprocesses like git equals our $PWD (for pathname comparisons).
779 cd -P "$TRASH_DIRECTORY" || exit 1
782 this_test=${this_test%%-*}
783 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
785 say_color info >&3 "skipping test $this_test altogether"
786 skip_all="skip all tests in $this_test"
790 # Provide an implementation of the 'yes' utility
805 # Fix some commands on Windows
808 # Windows has its own (incompatible) sort and find
818 # git sees Windows-style pwd
822 # no POSIX permissions
823 # backslashes in pathspec are converted to '/'
824 # exec does not inherit the PID
825 test_set_prereq MINGW
826 test_set_prereq NOT_CYGWIN
827 test_set_prereq SED_STRIPS_CR
828 test_set_prereq GREP_STRIPS_CR
831 test_set_prereq POSIXPERM
832 test_set_prereq EXECKEEPSPID
833 test_set_prereq NOT_MINGW
834 test_set_prereq CYGWIN
835 test_set_prereq SED_STRIPS_CR
836 test_set_prereq GREP_STRIPS_CR
839 test_set_prereq POSIXPERM
840 test_set_prereq BSLASHPSPEC
841 test_set_prereq EXECKEEPSPID
842 test_set_prereq NOT_MINGW
843 test_set_prereq NOT_CYGWIN
847 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
848 test -z "$NO_PERL" && test_set_prereq PERL
849 test -z "$NO_PYTHON" && test_set_prereq PYTHON
850 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
851 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
853 # Can we rely on git's output in the C locale?
854 if test -n "$GETTEXT_POISON"
856 GIT_GETTEXT_POISON=YesPlease
857 export GIT_GETTEXT_POISON
858 test_set_prereq GETTEXT_POISON
860 test_set_prereq C_LOCALE_OUTPUT
863 # Use this instead of test_cmp to compare files that contain expected and
864 # actual output from git commands that can be translated. When running
865 # under GETTEXT_POISON this pretends that the command produced expected
868 test -n "$GETTEXT_POISON" || test_cmp "$@"
871 # Use this instead of "grep expected-string actual" to see if the
872 # output from a git command that can be translated either contains an
873 # expected string, or does not contain an unwanted one. When running
874 # under GETTEXT_POISON this pretends that the command produced expected
877 if test -n "$GETTEXT_POISON"
880 elif test "x!" = "x$1"
889 test_lazy_prereq PIPE '
890 # test whether the filesystem supports FIFOs
896 rm -f testfifo && mkfifo testfifo
901 test_lazy_prereq SYMLINKS '
902 # test whether the filesystem supports symbolic links
903 ln -s x y && test -h y
906 test_lazy_prereq CASE_INSENSITIVE_FS '
907 echo good >CamelCase &&
908 echo bad >camelcase &&
909 test "$(cat CamelCase)" != good
912 test_lazy_prereq UTF8_NFD_TO_NFC '
913 # check whether FS converts nfd unicode to nfc
914 auml=$(printf "\303\244")
915 aumlcdiar=$(printf "\141\314\210")
925 test_lazy_prereq AUTOIDENT '
926 sane_unset GIT_AUTHOR_NAME &&
927 sane_unset GIT_AUTHOR_EMAIL &&
928 git var GIT_AUTHOR_IDENT
931 # When the tests are run as root, permission tests will report that
932 # things are writable when they shouldn't be.
933 test -w / || test_set_prereq SANITY
935 GIT_UNZIP=${GIT_UNZIP:-unzip}
936 test_lazy_prereq UNZIP '